package PoslovnaLogikaPonasanje;

import PoslovnaLogikaStruktura.*;
import java.util.Iterator;
import java.util.List;


public class LogikaSahovskaTabla
{   public int[][] mat = new int[8][8];
    int brojac=1;
    int indeksReda = 0;
    int indeksKolone = 0;
    public int strategija [] = {1,2,3,4,5,6,7,8};
        
    public LogikaSahovskaTabla()
    {   super();
        mat[0][0] = brojac;
    }

   public void inicijalizacijaIgre()
    {
      for (int x = 0; x < mat.length; x++)
           for (int y = 0; y < mat.length; y++)  
             { mat[x][y] = 0; 
             }
               
        brojac = 1;
        indeksReda = 0;
        indeksKolone = 0;
        mat[0][0] = brojac;
    }
    
    public int[][] pronaciPutOdGornjegLevogDoDonjegDesnogUgla(Strategija st)     
      { strategija = konvertujStringIDUNizID(st.vratiIDStrategija());
        inicijalizacijaIgre();
                
        while(true)
         { boolean signal = odrediIndekse();           
           if (signal == false)
             { System.out.println("Ne moze da nadje resenje - ne moze da izadje iz polja!!!");  
               break; 
             }
         
           if ((indeksReda == 7) && (indeksKolone == 7))
             { brojac++; 
               mat[7][7] = brojac;
               break;
             }  
           brojac++;
           
           if (brojac > 64)
           { System.out.println("Ne moze da nadje resenje - prosao sva polja!!!");  
             break; 
           }
           
           mat[indeksReda][indeksKolone] = brojac;
                      
           System.out.println("Indeks reda:" + indeksReda + " Indeks kolone:" + indeksKolone);
         }  
        return mat;
      }
    
  boolean odrediIndekse()
     { boolean signal = false; // polazi se od pretpostavke da nece pronaci indekse.
       int red = 0;
       int kolona = 0;
       for(int s:strategija)
            {  switch (s) {
                    case 1: red = 1; kolona = 2;   break; 
                    case 2: red = 2; kolona = 1;   break;
                    case 3: red = 2; kolona = -1;  break;
                    case 4: red = 1; kolona = -2;  break;
                    case 5: red = -1; kolona = -2; break;
                    case 6: red = -2; kolona = -1; break;
                    case 7: red = -2; kolona = 1;  break;
                    case 8: red = -1; kolona = 2;  break;   
                          } 
              signal = odrediStanjeIndeksa(red,kolona); 
              if (signal) break;
            }
        return signal;
     }     

  // o.2.1.1.3.3 (SO), (atomska metoda)
  public void odrediStrategiju(int strategija[])
   {this.strategija = strategija;}      
  
   
   boolean odrediStanjeIndeksa(int red,int kolona)
    {  boolean signal = false;
       indeksReda = indeksReda + red; // s1
       indeksKolone = indeksKolone + kolona;
       if (indeksReda < 8 && indeksReda >= 0 && indeksKolone < 8 && indeksKolone>=0)
        {  if (mat[indeksReda][indeksKolone]==0)
           { signal = true;
           }
           else
            { indeksReda = indeksReda - red;
              indeksKolone = indeksKolone - kolona;
            }
        }
      else
       { indeksReda = indeksReda - red;
         indeksKolone = indeksKolone - kolona;
       } 
     return signal;
    }  

   public int[][] vratiMatricuSahovskeTableSaStrategijom(Strategija st)
    { inicijalizacijaIgre();
      mat[0][0] = 0;
      ListaGeneralDObject lgo = new ListaGeneralDObject();
       new KVratiListuStanjaStrategije().vratiListuStanjaStrategije(lgo,st);
       List<StanjeStrategije> lss = (List) lgo.vratiListu();
       
       
      Iterator it = lss.iterator();
       while(it.hasNext())
        { StanjeStrategije ss = (StanjeStrategije) it.next();
          switch (ss.vratiStanje())
            { case 1: mat[4][5] = ss.vratiRedosled(); break;
              case 2: mat[5][4] = ss.vratiRedosled(); break;
              case 3: mat[5][2] = ss.vratiRedosled(); break;
              case 4: mat[4][1] = ss.vratiRedosled(); break;
              case 5: mat[2][1] = ss.vratiRedosled(); break;
              case 6: mat[1][2] = ss.vratiRedosled(); break;
              case 7: mat[1][4] = ss.vratiRedosled(); break;
              case 8: mat[2][5] = ss.vratiRedosled(); break;
            }      
        } 
       return mat;
    }      
   
   
   public int[][] vratiMatricuSahovskeTableSaPutanjom(Strategija st)
   {  inicijalizacijaIgre();
      mat[0][0] = 0;
      ListaGeneralDObject ls = new ListaGeneralDObject();
      new KVratiListuPutanja().vratiListuPutanja(ls,st);
      if (ls.vratiBrojElemenataListe()>0)
        { List <Putanja> put = (List)ls.vratiListu();
          mat = new int[8][8];
          Iterator it = put.iterator();
          while(it.hasNext())
          {  Putanja put1 = (Putanja) it.next();
             mat[put1.vratiX()][put1.vratiY()] = put1.vratiRedosled();
          }
         }
        else
         { mat = null;

         }
       System.out.println("vratiMatricuSahovskeTableSaPutanjom, mat:" + mat);
       return mat;
   }   
   
   //public int[][] vratiSahovskuTablu()
   //   {return mat;}      
   
   
   /*public void setStrategija(int strategija[])
    {this.strategija = strategija;}    
   
   public int[] getStrategija()
    { return strategija;}*/
 
   public int[] konvertujStringIDUNizID(String idStrategija)
    { int strategija[] = new int[8];  
      for(int i=0;i<idStrategija.length();i++)
        strategija[i] = Integer.parseInt(idStrategija.charAt(i) + "");
      return strategija;
    }
   
}